/*==============================================================================
* nrLDPC_lut.h
*
* Header file loading all look-up tables
*
* Author: Sebastian Wagner
* Date: 17-11-2017
*
===============================================================================*/

#ifndef __NR_LDPC_LUT__H__
#define __NR_LDPC_LUT__H__

// BG1
#include "lut_llr2CnProcBuf_BG1_Z128_R13.h"
#include "lut_cn2bnProcBuf_BG1_Z128_R13.h"
#include "lut_llr2llrProcBuf_BG1_Z128_R13.h"

#include "lut_llr2CnProcBuf_BG1_Z128_R23.h"
#include "lut_cn2bnProcBuf_BG1_Z128_R23.h"
#include "lut_llr2llrProcBuf_BG1_Z128_R23.h"

#include "lut_llr2CnProcBuf_BG1_Z128_R89.h"
#include "lut_cn2bnProcBuf_BG1_Z128_R89.h"
#include "lut_llr2llrProcBuf_BG1_Z128_R89.h"

#include "lut_llr2CnProcBuf_BG1_Z384_R13.h"
#include "lut_cn2bnProcBuf_BG1_Z384_R13.h"
#include "lut_llr2llrProcBuf_BG1_Z384_R13.h"

#include "lut_llr2CnProcBuf_BG1_Z384_R23.h"
#include "lut_cn2bnProcBuf_BG1_Z384_R23.h"
#include "lut_llr2llrProcBuf_BG1_Z384_R23.h"

#include "lut_llr2CnProcBuf_BG1_Z384_R89.h"
#include "lut_cn2bnProcBuf_BG1_Z384_R89.h"
#include "lut_llr2llrProcBuf_BG1_Z384_R89.h"

// BG2
#include "lut_llr2CnProcBuf_BG2_Z2_R15.h"
#include "lut_cn2bnProcBuf_BG2_Z2_R15.h"
#include "lut_llr2llrProcBuf_BG2_Z2_R15.h"

#include "lut_llr2CnProcBuf_BG2_Z2_R13.h"
#include "lut_cn2bnProcBuf_BG2_Z2_R13.h"
#include "lut_llr2llrProcBuf_BG2_Z2_R13.h"

#include "lut_llr2CnProcBuf_BG2_Z2_R23.h"
#include "lut_cn2bnProcBuf_BG2_Z2_R23.h"
#include "lut_llr2llrProcBuf_BG2_Z2_R23.h"

#include "lut_llr2CnProcBuf_BG2_Z80_R15.h"
#include "lut_cn2bnProcBuf_BG2_Z80_R15.h"
#include "lut_llr2llrProcBuf_BG2_Z80_R15.h"

#include "lut_llr2CnProcBuf_BG2_Z80_R13.h"
#include "lut_cn2bnProcBuf_BG2_Z80_R13.h"
#include "lut_llr2llrProcBuf_BG2_Z80_R13.h"

#include "lut_llr2CnProcBuf_BG2_Z80_R23.h"
#include "lut_cn2bnProcBuf_BG2_Z80_R23.h"
#include "lut_llr2llrProcBuf_BG2_Z80_R23.h"

#include "lut_llr2CnProcBuf_BG2_Z128_R15.h"
#include "lut_cn2bnProcBuf_BG2_Z128_R15.h"
#include "lut_llr2llrProcBuf_BG2_Z128_R15.h"

#include "lut_llr2CnProcBuf_BG2_Z128_R13.h"
#include "lut_cn2bnProcBuf_BG2_Z128_R13.h"
#include "lut_llr2llrProcBuf_BG2_Z128_R13.h"

#include "lut_llr2CnProcBuf_BG2_Z128_R23.h"
#include "lut_cn2bnProcBuf_BG2_Z128_R23.h"
#include "lut_llr2llrProcBuf_BG2_Z128_R23.h"

#include "lut_llr2CnProcBuf_BG2_Z384_R15.h"
#include "lut_cn2bnProcBuf_BG2_Z384_R15.h"
#include "lut_llr2llrProcBuf_BG2_Z384_R15.h"

#include "lut_llr2CnProcBuf_BG2_Z384_R13.h"
#include "lut_cn2bnProcBuf_BG2_Z384_R13.h"
#include "lut_llr2llrProcBuf_BG2_Z384_R13.h"

#include "lut_llr2CnProcBuf_BG2_Z384_R23.h"
#include "lut_cn2bnProcBuf_BG2_Z384_R23.h"
#include "lut_llr2llrProcBuf_BG2_Z384_R23.h"

#endif
